"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const FromData = require("form-data");
const NativeAdapter_1 = require("../http/NativeAdapter");
const formdata = (request) => {
    const data = new FromData();
    const values = request.getFormValues();
    for (const field in values) {
        if (values.hasOwnProperty(field)) {
            const value = values[field];
            if (value !== undefined) {
                data.append(field, String(value));
            }
        }
    }
    const files = request.getFormFiles();
    for (const filename in files) {
        if (files.hasOwnProperty(filename)) {
            const document = files[filename];
            if (document !== undefined) {
                data.append(filename, document.getStream(), { filename });
            }
        }
    }
    return data;
};
class Client {
    constructor(url, client = new NativeAdapter_1.NativeAdapter()) {
        this.url = url;
        this.client = client;
    }
    do(request) {
        return this.client.post(this.url + request.getPostURL(), formdata(request));
    }
}
exports.Client = Client;
