"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const stream_1 = require("stream");
const _Document_1 = require("./_Document");
class ReadableBuffer extends stream_1.Readable {
    constructor(body) {
        super();
        this.sent = false;
        this.body = body instanceof Buffer ? body : Buffer.from(body);
    }
    _read() {
        if (!this.sent) {
            this.push(this.body);
            this.sent = true;
        }
        else {
            this.push(null);
        }
    }
}
class InplaceDocument extends _Document_1.Document {
    constructor(fileName, body) {
        super(fileName);
        this.body = body;
    }
    getStream() {
        return new ReadableBuffer(this.body);
    }
}
exports.InplaceDocument = InplaceDocument;
class StringDocument extends InplaceDocument {
}
exports.StringDocument = StringDocument;
class BufferDocument extends InplaceDocument {
}
exports.BufferDocument = BufferDocument;
