"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const http = require("http");
const https = require("https");
const _Adapter_1 = require("./_Adapter");
class NativeAdapter extends _Adapter_1.HttpAdapter {
    post(url, data) {
        const _url = url instanceof URL ? url : new URL(url);
        const request = _url.protocol === 'http:' ? http.request : https.request;
        return new Promise((resolve, reject) => {
            const req = request(_url, {
                method: 'POST',
                headers: data.getHeaders(),
            });
            req.on('error', reject);
            req.on('response', res => {
                if (res.statusCode === 200) {
                    resolve(res);
                }
                else {
                    res.resume();
                    reject(new Error(res.statusCode + ' ' + res.statusMessage));
                }
            });
            data.pipe(req);
        });
    }
}
exports.NativeAdapter = NativeAdapter;
