"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _Request_1 = require("./_Request");
const _Document_1 = require("../document/_Document");
const LANDSCAPE = 'landscape';
class OfficeRequest extends _Request_1.Request {
    constructor(...files) {
        super();
        this._landscape = false;
        this._files = files || [];
    }
    getPostURL() {
        return '/convert/office';
    }
    getFormValues() {
        return Object.assign(Object.assign({}, super.getFormValues()), { [LANDSCAPE]: this._landscape });
    }
    getFormFiles() {
        return Object.assign(Object.assign({}, super.getFormFiles()), _Document_1.reduce(this._files));
    }
    landscape(value) {
        this._landscape = value;
        return this;
    }
}
exports.OfficeRequest = OfficeRequest;
