import { FormFiles, FormValues, GotenbergRequest } from './_GotenbergRequest';
import { Request } from './_Request';
import { Document } from '../document/_Document';
import { Margins, PageSize } from '../page';
export declare abstract class ChromeRequest extends Request implements GotenbergRequest {
    private _header?;
    private _footer?;
    private _waitDelay?;
    private _paperWidth?;
    private _paperHeight?;
    private _marginTop?;
    private _marginBottom?;
    private _marginLeft?;
    private _marginRight?;
    private _landscape?;
    private _googleChromeRpccBufferSize?;
    getFormValues(): FormValues;
    getFormFiles(): FormFiles;
    header(header: Document): ChromeRequest;
    footer(footer: Document): ChromeRequest;
    waitDelay(value: number): ChromeRequest;
    paperSize(size: PageSize): ChromeRequest;
    paperWidth(value: number): ChromeRequest;
    paperHeight(value: number): ChromeRequest;
    margins(margins: Margins): ChromeRequest;
    marginTop(value: number): ChromeRequest;
    marginRight(value: number): ChromeRequest;
    marginBottom(value: number): ChromeRequest;
    marginLeft(value: number): ChromeRequest;
    landscape(value: boolean): ChromeRequest;
    googleChromeRpccBufferSize(value: number): ChromeRequest;
}
