"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const _Request_1 = require("./_Request");
const HEADER_TEMPLATE = 'header.html';
const FOOTER_TEMPLATE = 'footer.html';
const WAIT_DELAY = 'waitDelay';
const PAPER_WIDTH = 'paperWidth';
const PAPER_HEIGHT = 'paperHeight';
const MARGIN_TOP = 'marginTop';
const MARGIN_BOTTOM = 'marginBottom';
const MARGIN_LEFT = 'marginLeft';
const MARGIN_RIGHT = 'marginRight';
const LANDSCAPE = 'landscape';
const GOOGLE_CHROME_RPCC_BUFFER_SIZE = 'googleChromeRpccBufferSize';
class ChromeRequest extends _Request_1.Request {
    constructor() {
        super(...arguments);
        this._landscape = false;
    }
    getFormValues() {
        return Object.assign(Object.assign({}, super.getFormValues()), { [WAIT_DELAY]: this._waitDelay, [PAPER_WIDTH]: this._paperWidth, [PAPER_HEIGHT]: this._paperHeight, [MARGIN_TOP]: this._marginTop, [MARGIN_BOTTOM]: this._marginBottom, [MARGIN_LEFT]: this._marginLeft, [MARGIN_RIGHT]: this._marginRight, [GOOGLE_CHROME_RPCC_BUFFER_SIZE]: this._googleChromeRpccBufferSize, [LANDSCAPE]: this._landscape });
    }
    getFormFiles() {
        return Object.assign(Object.assign({}, super.getFormFiles()), { [HEADER_TEMPLATE]: this._header, [FOOTER_TEMPLATE]: this._footer });
    }
    header(header) {
        this._header = header;
        return this;
    }
    footer(footer) {
        this._footer = footer;
        return this;
    }
    waitDelay(value) {
        this._waitDelay = value;
        return this;
    }
    paperSize(size) {
        if (Array.isArray(size)) {
            ;
            [this._paperWidth, this._paperHeight] = size;
        }
        else {
            ;
            ({ width: this._paperWidth, height: this._paperHeight } = size);
        }
        return this;
    }
    paperWidth(value) {
        this._paperWidth = value;
        return this;
    }
    paperHeight(value) {
        this._paperHeight = value;
        return this;
    }
    margins(margins) {
        if (Array.isArray(margins)) {
            ;
            [
                this._marginTop,
                this._marginRight,
                this._marginBottom,
                this._marginLeft,
            ] = margins;
        }
        else {
            ;
            ({
                top: this._marginTop,
                right: this._marginRight,
                bottom: this._marginBottom,
                left: this._marginLeft,
            } = margins);
        }
        return this;
    }
    marginTop(value) {
        this._marginTop = value;
        return this;
    }
    marginRight(value) {
        this._marginRight = value;
        return this;
    }
    marginBottom(value) {
        this._marginBottom = value;
        return this;
    }
    marginLeft(value) {
        this._marginLeft = value;
        return this;
    }
    landscape(value) {
        this._landscape = value;
        return this;
    }
    googleChromeRpccBufferSize(value) {
        this._googleChromeRpccBufferSize = value;
        return this;
    }
}
exports.ChromeRequest = ChromeRequest;
